/**
 * Created by joyxu on 2016/4/13.
 */
var React = require("react");
var WidgetFactory = require("../widget/widgetFactory");

//表单布局里的元素容器,主要决定位置
module.exports = React.createClass({

    widget: null,

    getInitialState: function() {
        return {
            options: null
        }
    },

    render: function() {
        var options = this.getOptions();
        var style = {
            left: options.x,
            top: options.y
        };
        if(options.width) {
            style.width = options.width;
        }
        if(options.height) {
            style.height = options.height;
        }
        this.widget = this.createWidget(this.getOptions().content);
        var className = "h5-layout-container" + (options.isSingle ? " h5-layout-container-single" : "");
        return (
            <div className={className} style={style}>
                {this.widget}
            </div>
        );
    },

    createWidget: function(widgetOptions) {
        widgetOptions.sessionID = this.props.sessionID;
        widgetOptions.width = this.getOptions().width ? this.getOptions().width : widgetOptions.width;
        widgetOptions.height = this.getOptions().height ? this.getOptions().height : widgetOptions.height;
        widgetOptions.initLink = this.props.initLink;
        widgetOptions.fireWidgetValueChange = this.props.fireWidgetValueChange;
        widgetOptions.hasFormBackground = this.props.hasFormBackground;
        widgetOptions.fireWidgetLink = this.props.fireWidgetLink;
        widgetOptions.onDoHyperLink = this.props.onDoHyperLink;
        return WidgetFactory.createWidget(widgetOptions);
    },

    _getWidgetName: function() {
        return this.getOptions().content.widgetName;
    },

    getWidget: function() {
        return this.refs[this._getWidgetName()];
    },

    getOptions: function() {
        return this.state.options ? this.state.options : this.props.options;
    }

});