var React = require("react");
var NavigationBarItem = require("./navigationBarItem");

//二级及以后目录树上的导航条
module.exports = React.createClass({

    getInitialState: function() {
        return {
            items: [],
            selectedIndex: 0
        }
    },

    render: function() {
        var self = this;
        var items = this.getItems();
        var elements = [];
        $.map(items, function(item, index) { //item:{id:xx,text:xx}
            var selected = (index == self.state.selectedIndex);
            var isFirst = (index === 0);
            elements.push(<NavigationBarItem key={item.id} onClick={self.onClick} text={item.text} selected={selected} isFirst={isFirst}></NavigationBarItem>);
        });
        return (
            <div className="h5-navigation">
                {elements}
            </div>
        );
    },

    onClick: function(e) {
        var element = $(e.target);
        if(element.hasClass("h5-navigation-item-text") || element[0].nodeName.toLocaleLowerCase() != "span") {
            element = element.parent();
        }
        var elements = element.parent().children();
        var index = elements.indexOf(element[0]);
        var tempItems = this.getItems();
        var newItems = tempItems.splice(0, index + 1);
        this.props.onClick(newItems[index].id, tempItems);
        this.setState({
            items: newItems,
            selectedIndex: newItems.length - 1
        });
    },

    getItems: function() {
        return this.state.items.length > 0 ? this.state.items : this.props.defaultItems;
    },

    addItem: function(item) {
        var items = this.getItems().concat(item);
        this.setState({
            items: items,
            selectedIndex: items.length - 1
        });
    }
});