var React = require("react");
var ReactDOM = require("react-dom");
var NavigationBar = require("./navigationBar");
var EntryItem = require("./entryItem");
var BaseUtils = require("../../utils/baseUtils");
var DirectoryUtils = require("./../../utils/directoryUtils");

//二级以及以后的目录树
module.exports = React.createClass({

    startX: 0,

    startY: 0,

    originalLeft: 0,

    width: 0,

    startScrollTop: 0,

    scrollDirection: -1,    // -1:未确定,0:横向,1:纵向

    moveX: [],

    selectedEntryManager: {},   //记录下已经选中的entry的数据信息

    touchStartTime: 0,

    COOKIE_SELECTED_FOLDER_ID: "folderSelectedID",

    getInitialState: function() {
        return {
            items: null,
            entryID: null,
            entryText: null
        }
    },

    componentDidMount: function() {
        var self = this;
        $(".h5-sub-directory").tap(function(e) {
            self.onItemClick(e);
        });
    },

    render: function() {
        var self = this;
        var elements = [];
        $.map(this.getItems(), function(item, index) {
            // if(!DirectoryUtils.isEmptyDirectory(item)) {
                var icon = "icon-tree-" + self.getType(item);
                elements.push(<li key={index}><EntryItem icon={icon} text={item.text}></EntryItem></li>);
            // }
        });
        return (
            <div className="h5-sub-directory" onTouchStart={this.onTouchStart} onTouchMove={this.onTouchMove} onTouchEnd={this.onTouchEnd}>
                <NavigationBar key="navigationBar" ref="navigationBar" defaultItems={[{id: this.getEntryID(), text:this.getEntryText()}]} onClick={this.onNavFolderSelect}/>
                <div key="subList" ref="subList" className="h5-sub-directory-list">
                    <ul>
                        {elements}
                    </ul>
                </div>
            </div>
        )
    },

    getItems: function() {
        return this.state.items != null ? this.state.items : this.props.defaultItems;
    },

    getEntryID: function() {
        return this.state.entryID ? this.state.entryID : this.props.defaultEntryID;
    },

    getEntryText: function() {
        return this.state.entryText ? this.state.entryText : this.props.defaultEntryText;
    },

    onNavFolderSelect: function(entryID, removeEntryIDs) {
        var self = this;
        var items = this.selectedEntryManager[entryID];
        $.map(removeEntryIDs, function(removeEntryID, index) {
            delete self.selectedEntryManager[removeEntryID];
        });
        this.setState({
            items: items
        });
    },

    onItemClick: function(e) {
        var index = BaseUtils.getSelectedIndex($(e.target), "li");
        if(index < 0) {
            return ;
        }
        var entry = this.getItems()[index];
        var entryType = this.getType(entry);
        if(entryType == "folder") {
            var childrenNodes = entry.ChildNodes ? entry.ChildNodes : [];
            this.selectedEntryManager[entry.id] = childrenNodes;
            this.saveSelectedFolders();
            this.setState({
                items: childrenNodes
            });
            this.refs["navigationBar"].addItem({
                id: entry.id,
                text: entry.text
            });
        } else {
            this.props.onEnterEntry();
            if(entryType == "cpt" || entryType == "frm") {
                BaseUtils.openWindow(FRH5ReportConstants.servletURL + "?op=h5_entry&cmd=entry_report&id=" + entry.id);
            } else if(entryType == "bi") {
                BaseUtils.openWindow(FRH5ReportConstants.servletURL + entry.bilink);
            } else {
                BaseUtils.openWindow(FRH5ReportConstants.servletURL + "?op=fs_main&cmd=entry_report&id=" + entry.id);
            }
        }
    },

    setSelectedEntry: function(selectedEntry, id, text) {
        this.selectedEntryManager = selectedEntry;
        this.refs["navigationBar"].setState({
            items: [{id: id, text: text}],
            selectedIndex: 0
        });
    },

    onTouchStart: function(e) {
        var item = BaseUtils.getSelectedElement($(e.target), "li");
        item && item.addClass("h5-entry-item-active");
        this.touchStartTime = (new Date()).getTime();
        this.originalLeft = $(ReactDOM.findDOMNode(this)).offset().left;
        this.width = $(ReactDOM.findDOMNode(this)).width();
        this.startX = e.touches[0].pageX,
        this.startY = e.touches[0].pageY;
        this.startScrollTop = $(".h5-sub-directory-wrap").scrollTop();
        this.addTransitioningClass(false);
        e.preventDefault();
    },

    onTouchMove: function(e) {
        if(BaseUtils.isAndroid() && ((new Date()).getTime() - this.touchStartTime < 100)) {
            //安卓设备加个延迟,可能因为很多屏幕灵敏度一般,click事件总是会走到move,iOS就无此问题
            return ;
        }
        var touch = e.touches[0];
        var self = this;
        var moveEndX = touch.pageX;
        var moveEndY = touch.pageY;
        var X = moveEndX - self.startX;
        var Y = moveEndY - self.startY;
        if(self.scrollDirection < 0) {
            self.scrollDirection = Math.abs(X) > Math.abs(Y) ? 0 : 1;
        }
        if (self.scrollDirection == 0) {
            BaseUtils.setTranslate3D($(".h5-sub-directory-wrap"), "translate3d(" + Math.max(0, X) + "px, 0, 0)");
            var percent = X / self.width;
//                self.props.onMove(percent);   //有性能问题
            if(self.moveX[self.moveX.length - 1] != moveEndX) {
                self.moveX.push(moveEndX);
            }
        } else if(self.scrollDirection == 1) {
            $(".h5-sub-directory-wrap").scrollTop(Math.max(0, self.startScrollTop - Y));
        }
        e.preventDefault();
    },

    onTouchEnd: function(e) {
        var self = this;
        $(".h5-entry-item-active").removeClass("h5-entry-item-active");
        if(this.scrollDirection == 0) {
            this.addTransitioningClass(true);
            if(this.moveX.length > 2 && this.moveX[this.moveX.length - 2] < this.moveX[this.moveX.length - 1]) {
                //最后的手势是向右
                this.props.fadeOut();
            } else {
                //向左,返回原样
                this.props.fadeIn(true);
            }
        }
        this.scrollDirection = -1;
        this.moveX = [];
        e.preventDefault();
    },

    saveSelectedFolders: function() {
        var selectedEntryIDs = [];
        $.map(this.selectedEntryManager, function(childrenNodes, entryID) {
            selectedEntryIDs.push(entryID);
        });
        BaseUtils.setCookie(this.COOKIE_SELECTED_FOLDER_ID, selectedEntryIDs);
    },

    addTransitioningClass: function(add) {
        var subWrap = $(".h5-sub-directory-wrap");
        if(add) {
            subWrap.addClass("h5-sub-directory-wrap-transitioning");
        } else {
            subWrap.removeClass("h5-sub-directory-wrap-transitioning");
        }
    },

    getType: function(item) {
        if(item.nodeicon) {
            return item.nodeicon;
        } else if(item.type == "0"){
            return "folder";
        }
        return "url";
    }
});