/**
 * Created by Wei on 15/12/23.
 */

var React = require('react');
var ReactDOM = require('react-dom');
var WidgetFactory = require('../widget/widgetFactory.js');
require('../../dist/css/h5.css');
var BaseUtils = require("../../utils/baseUtils");
var WidgetUtils = require("../../utils/widgetUtils");
var LabelWidget = require("../widget/labelWidget");

/**
 * props:data
 */
module.exports = React.createClass({

    widgetUtils: null,

    componentWillMount: function() {
        this.widgetUtils = $.extend(true, {}, WidgetUtils);
    },

    componentDidMount: function() {
        var self = this;
        this.widgetUtils.widgetsInitLink(this.refs);
        if(this.props.isDelay === false) {
            //立刻查询
            this.onSubmit(function() {
                $(ReactDOM.findDOMNode(self)).removeClass("h5-para-pane-hidden");
            });
        } else {
            $(ReactDOM.findDOMNode(this)).removeClass("h5-para-pane-hidden");
        }
    },

    render: function() {
        var self = this;
        var options = this.props.options;
        var parameterWidgets = options["parameter"];
        var sessionID = BaseUtils.getSessionID(options);
        var fitConfig = BaseUtils.jsonEncode(options["fitConfig"]);
        var widgets = [];
        var widgetNameList = [];
        parameterWidgets.map(function(parameterWidget, index) {
            var widgetName = parameterWidget["widget"]["widgetName"];
            var labelWidget = <LabelWidget key={widgetName} ref={widgetName} options={parameterWidget} sessionID={sessionID}
                initLink={self.initLink} fireWidgetValueChange={self.fireWidgetValueChange}></LabelWidget>;
            widgetNameList.push(widgetName);
            widgets.push(labelWidget);
        });
        widgets.push(<div key="submit" id="h5-submit-wrap" className="wrap_i">
                        {WidgetFactory.createWidget({type:"submitButton", onClick:this.onSubmitClick, sessionid:sessionID})}
                    </div>);
        widgets.push(<div ref="cancel" key="cancel" id="h5-cancel-wrap" className="wrap_i h5-cancel-hidden">
                    {WidgetFactory.createWidget({type:"cancelButton", onClick:this.onCancelClick, sessionid:sessionID})}
                </div>);
        return (
            <div className="h5-para-pane h5-para-pane-hidden">
                {widgets}
            </div>
        );
    },

    initLink: function(widget) {
        this.widgetUtils.initLink(widget);
    },

    fireWidgetValueChange: function(widget) {
        this.widgetUtils.fireWidgetValueChange(widget);
    },

    collectWidgetValues: function() {
        return this.widgetUtils.collectWidgetValues();
    },

    onSubmitClick: function(e) {
        FRH5ReportUtils.beforeClick();
        this.onSubmit(e);
    },

    onCancelClick: function(e) {
        FRH5ReportUtils.beforeClick();
        FRH5ReportUtils.beforeShowContent();
    },

    onSubmit: function(callback) {
        var self = this;
        var options = this.props.options;
        if(!this.widgetUtils.validateWidget()) {
            return ;
        }
        var widgetValues = {};
        widgetValues = this.collectWidgetValues();
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType:'text',
            data: {
                op: "fr_dialog",
                cmd: "parameters_d",
                sessionID: BaseUtils.getSessionID(options),
                __parameters__:  widgetValues
            },
            type: "POST",
            success:function(responseObject) {
                if($.isFunction(self.props.onSubmit)) {
                    self.props.onSubmit();
                }
                if($.isFunction(callback)) {
                    callback.call();
                }
            },
            error: function() {
                if($.isFunction(self.props.onSubmit)) {
                    self.props.onSubmit();
                }
                if($.isFunction(callback)) {
                    callback.call();
                }
            }
        });
    }
});