var React = require("react");
var ReactDOM = require("react-dom");
var ToolbarGroup = require("./toolbarGroup");

module.exports = React.createClass({
    hideTimer: null,

    toolbarButtons: {},

    componentDidMount: function() {
        var self = this;
        this.refreshHideTimer();
        $(document).on("gesturestart", function() {
            self.hide();
        });
    },

    getInitialState: function() {
        return {
            show: true,
            autoDisappearTime: 5000
        }
    },

    render: function() {
        var className = "h5-toolbar";
        if(!this.state.show) {
            className = "h5-toolbar h5-toolbar-hide";
        }
        var buttonGroups = [];
        $.map(this.props.buttons, function(buttonGroup, index) {
            buttonGroups.push(<ToolbarGroup ref={buttonGroup["key"]} buttons={buttonGroup["buttons"]} width={buttonGroup["width"]} key={buttonGroup["key"]} />);
        });
        return (
            <div className={className}>
                {buttonGroups}
            </div>
        );
    },

    refreshHideTimer: function() {
        var self = this;
        if(this.hideTimer) {
            clearTimeout(this.hideTimer);
        }
        this.hideTimer = setTimeout(function() {
            self.hide();
        }, this.state.autoDisappearTime);
    },

    changeVisibility:function(){
        if(this.hideTimer) {
            clearTimeout(this.hideTimer);
        }
        if(this.state.show){
            this.hide();
        }else{
            this.show();
        }
    },

    hide: function() {
        if(this.hideTimer) {
            clearTimeout(this.hideTimer);
        }
        this.setState({
            show: false
        });
    },

    show: function() {
        var self = this;
        this.setState({
            show: true,
        });
        this.hideTimer = setTimeout(function() {
            self.hide();
        }, this.state.autoDisappearTime);
    },

    getButtonByKey: function(key) {

    }
});