var React = require("react");
var ReactDOM = require("react-dom");
var BaseUtils = require("../../utils/baseUtils");

module.exports = React.createClass({
    baseClass: "h5-toolbar-button",

    enable: true,

    getInitialState: function() {
        return {
            text: ""
        };
    },

    componentWillMount: function() {
        this.setState({
            text:this.props.text
        });
    },

    componentDidMount: function() {
        var self = this;
        if(this.props.noActive !== true) {
            BaseUtils.createMoveInAndOutEvent($(ReactDOM.findDOMNode(this)), function() {
                if(self.isEnable()) {
                    $(ReactDOM.findDOMNode(self)).addClass(self.baseClass + "-active");
                }
            }, function() {
                $(ReactDOM.findDOMNode(self)).removeClass(self.baseClass + "-active");
            });
            BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this)), this.props.onClick);
        }
        if(this.props.disable) {
            this.setEnable(false);
        }
    },

    render: function() {
        var className = this.baseClass;
        if(this.props.className) {
            className += (" " + this.props.className);
        }
        return <div style={{width:this.props.width}} className={className}>{this.state.text}</div>
    },

    setEnable: function(enable) {
        if(enable) {
            $(ReactDOM.findDOMNode(this)).removeClass(this.baseClass + "-disable");
            this.enable = true;
        } else {
            $(ReactDOM.findDOMNode(this)).addClass(this.baseClass + "-disable");
            $(ReactDOM.findDOMNode(this)).removeClass(this.baseClass + "-active");
            this.enable = false;
        }
    },

    isEnable: function() {
        return this.enable;
    }
});