/**
 * Created by Wei on 15/12/28.
 */
var React = require("react");
var ReactDOM = require('react-dom');
var Widget = require("../widget");
var Group = require("./groupEditor");
var GroupItem = require("./groupItem");
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({
    ref: "checkGroup",
    mixins: [Widget, Group],
    delimiter: ',',

    getInitialState: function () {
        return {
            selectedIndexes: []
        }
    },

    componentWillMount: function () {
        //render之前，进行一些数据的初始化工作
        var options = this.props.options;
        this.delimiter = options.delimiter ? options.delimiter : ",";
        var value = this.props.options.value;
        if (value != '') {
            var tmpList = [];
            var array = BaseUtils.toArray(value, this.delimiter);
            for (var i = 0; i < array.length; i++) {
                tmpList.push(this.getIndexInData(array[i], true));   //默认值只允许设为实际值
            }
            this.setState({
                selectedIndexes: tmpList
            });
        }
    },

    render: function () {
        var index = 0;
        var items = [];
        var itemsData = this.getItemsData();
        for (; index < itemsData.length; index++) {
            var itemData = itemsData[index];
            var text = itemData.text;
            var item = this.createItem(text, index);
            items.push(item);
        }
        return <div ref={this.ref} className="h5-check-group">
            <ul>{items}</ul>
        </div>;
    },

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    createItem: function (text, index) {
        return <GroupItem key={index} type="check" text={text} onClick={this.doWhenCheck} isSelected={this.state.selectedIndexes.indexOf(index) >= 0} />;
    },

    doWhenCheck: function (e) {
        if(this.props.options.disabled) {
            return ;
        }
        var item = $(e.target);
        if (item[0].nodeName.toLocaleLowerCase() != "div") {
            item = item.parent();
        }
        var selectedItemParent = item.parent();
        var items = $(selectedItemParent).parent().children();
        var index = items.indexOf(selectedItemParent[0]);
        var tempSelectedIndexes = this.state.selectedIndexes;
        if (tempSelectedIndexes.indexOf(index) >= 0) {
            tempSelectedIndexes.splice(tempSelectedIndexes.indexOf(index), 1);
        } else {
            tempSelectedIndexes.push(index);
        }
        this.setState({
            selectedIndexes: tempSelectedIndexes
        });
        this.fireWidgetValueChange();
        BaseUtils.stopEvent(e);
    },

    getSelectedData: function (isValue) {
        var key = isValue ? "value" : "text";
        var selectedData = [];
        var itemsData = this.getItemsData();
        for (var i = 0, len = this.state.selectedIndexes.length; i < len; i++) {
            if(itemsData[this.state.selectedIndexes[i]]) {
                selectedData.push(itemsData[this.state.selectedIndexes[i]][key]);
            }
        }
        return selectedData;
    },

    getValue: function () {
        if (this.state.selectedIndexes.length == 0) {
            return "";
        }
        var options = this.props.options;
        var selectedData = this.getSelectedData(true);
        if (options.returnArray) {
            return selectedData;
        } else {
            var delimiter = options.delimiter ? options.delimiter : ",";
            return selectedData.join(delimiter);
        }
    },

    setValue: function (value) {
        if (value != '') {
            var tmpList = [];
            var array = BaseUtils.toArray(value, this.delimiter);
            for (var i = 0; i < array.length; i++) {
                tmpList.push(this.getIndexInData(array[i], false));
            }
            this.setState({
                selectedIndexes: tmpList
            });
        } else {
            this.reset();
        }
    },

    reset: function () {
        this.setState({
            selectedIndexes: []
        });
    }
});