/**
 * Created by Wei on 15/12/28.
 */

var React = require("react");
var ReactDOM = require('react-dom');
var Widget = require("../widget");
var Group = require("./groupEditor");
var GroupItem = require("./groupItem");
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({
    ref: "radioGroup",
    mixins: [Widget, Group],

    getInitialState: function () {
        return {
            selectedIndex: -1
        }
    },

    componentWillMount: function() {
        var value = this.props.options.value;
        if (value != '') {
            this.setState({
                selectedIndex:  this.getIndexInData(value, false)
            });
        }
    },

    render: function () {
        var index = 0;
        var items = [];
        var itemsData = this.getItemsData();
        for (; index < itemsData.length; index++) {
            var itemData = itemsData[index];
            var text = itemData.text;
            var item = this.createItem(text, index);
            items.push(item);
        }
        return (
            <div ref={this.ref} className="h5-radio-group">
                <ul>
                    {items}
                </ul>
            </div>
        );
    },

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    createItem: function (text, index) {
        return <GroupItem key={index} type="radio" text={text} onClick={this.doWhenCheck} isSelected={this.state.selectedIndex === index} />;
    },

    doWhenCheck: function (e) {
        if(this.props.options.disabled) {
            return ;
        }
        var item = $(e.target);
        if (item[0].nodeName.toLocaleLowerCase() != "div") {
            item = item.parent();
        }
        var selectedItemParent = item.parent();
        var items = $(selectedItemParent).parent().children();
        var selectedIndex = items.indexOf(selectedItemParent[0]);
        this.state.selectedIndex = selectedIndex;
        this.setState({
            selectedIndex: selectedIndex
        });
        this.fireWidgetValueChange();
        BaseUtils.stopEvent(e);
    },

    getSelectedData: function (isValue) {
        var key = isValue ? "value" : "text";
        var itemsData = this.getItemsData();
        if(itemsData[this.state.selectedIndex]) {
            return itemsData[this.state.selectedIndex][key];
        }
        return null;
    },

    getValue: function () {
        if (this.state.selectedIndex == -1) {
            return "";
        }
        return this.getSelectedData(true);
    },

    setValue: function (value) {
        if (value != '') {
            this.setState({
                selectedIndex: this.getIndexInData(value, false)
            });
        } else {
            this.reset();
        }
    },

    reset: function () {
        this.setState({
            selectedIndex: -1
        });
    }

});