/**
 * Created by Wei on 15/12/28.
 */

var React = require('react');
var Widget = require("../widget");
var TextBase = require('./textbase');
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({

    mixins : [Widget, TextBase],

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    render: function() {
        var options = this.props.options;
        this.attr = this.getAttrFromOptions(options);
        this.attr.value = (this.state && this.state.value !== undefined) ? this.state.value : options.value;
        if(options.allowDecimals === false){
            if(options.allowNegative === false){
                this.matchPatter ='^[0-9]{0,'+ options.maxIntLength+'}$';//正整数
            }else{
                this.matchPatter = '^\-?[0-9]{0,'+ options.maxIntLength+'}$';//整数
            }
        }else{
            if(options.allowNegative === false){
                this.matchPatter = '^(([0-9]{0,'+ options.maxIntLength+'}).)?([0-9]{0,'+ options.maxDecLength+'})?$';//正浮点数
            }else {
                this.matchPatter = '^-?(([0-9]{0,'+ options.maxIntLength+'}).)?([0-9]{0,'+ options.maxDecLength+'})?$';//浮点数
            }
        }
        return <input className="h5-text-editor" {...this.attr} onChange={this.handleChange}></input>;
    },

    isValidateInput: function(text) {
        return text.match(this.matchPatter) != null
    },

    verifyValue: function(text){
        if(text == "-" || text == ""){
            text = "0";
        }

        var result = true;

        if(this.props.options.maxValue) {
            result &= this.props.options.maxValue > text;
        }

        if(this.props.options.minValue){
            result &= text > this.props.options.minValue;
        }

        return result;
    },

    isValidate: function() {
        var value = this.getValue();
        var options = this.props.options;
        if(!this.validateBlank()) {
            this.errorMsg = BaseUtils.unicode2CJK("z503cz4e0dz5141z8bb8z4e3az7a7a");
            return false;
        }
        if(!this.isValidateInput(value)) {
            this.errorMsg = BaseUtils.unicode2CJK("z8f93z5165z503cz4e0dz7b26z5408z89c4z8303");
            return false;
        }
        if((options.maxValue && value > options.maxValue) || (options.minValue && value < options.minValue)) {
            this.errorMsg = BaseUtils.unicode2CJK("z53eaz5141z8bb8z8f93z5165") + options.minValue + BaseUtils.unicode2CJK("z5230") + options.maxValue + BaseUtils.unicode2CJK("z4e4bz95f4z7684z503c");
            return false;
        }
        return true;
    }
});