var React = require("react");
var Widget = require('./widget');
var BaseUtils = require('../../utils/baseUtils');
var ReactDOM = require('react-dom');

module.exports = React.createClass({

    getInitialState: function() {
        return {
            text: null
        }
    },

    mixins: [Widget],

    componentDidMount: function () {
        this.afterWidgetInit();
    },

    render: function() {
        var options = this.props.options;
        var labelClassName = "h5-label-normal";
        var labelContainerName = "h5-label-container";
        var containerStyle = {};
        labelClassName += (options.wrap ? " h5-label-wrap" : " h5-label-singleline");
        if(options.verticalcenter){
            labelContainerName += " h5-label-verticalcenter";
        }
        return <div className={labelContainerName} style={containerStyle}><div className={labelClassName} ref="label" style={this.getLabelStyle()}>{this.getText()}</div></div>
    },

    getValue: function() {
        return this.getText();
    },

    setValue: function(value) {
        this.setState({
            text: value
        });
    },

    getLabelStyle: function() {
        var options = this.props.options;
        var style = {
            color: options.color,
            textDecoration: options.decoration,
            fontSize: options.fontsize,
            textAlign: options.textalign,
            fontStyle: options.fontstyle,
        }
        if(options.width) {
            style.width = options.width;
        }
        $.extend(true, style, this.getBorderStyle());
        BaseUtils.analyseBackground(options.widgetBackground,style);
        return style;
    },

    getText: function() {
        return (this.state.text !== null) ? this.state.text : (this.props.options.text || this.props.options.value);
    },

    reset: function() {
        this.state.text = "";
        this.setState({
            text: ""
        });
    }
});