var React = require("react");
var Widget = require("./widget");
var Label = require("./label");
var WidgetFactory = require("./widgetFactory");

module.exports = React.createClass({

    render: function() {
        var options = this.props.options;
        var attr = {};
        var style = {};
        if(options["widget"].invisible) {
            style.display = "none";
        }
        if(options["widget"].disabled) {
            style.opacity = "0.5";
        }
        attr.style = style;
        var labelComponent = null;
        var widget = options["widget"];
        widget["sessionID"] = this.props.sessionID;
        widget["initLink"] = this.props.initLink;
        widget["fireWidgetValueChange"] = this.props.fireWidgetValueChange;
        var widgetComponent = WidgetFactory.createWidget(widget);
        var labelComponent = null;
        if(options["label"]) {
            labelComponent = <Label options={{text:options["label"]}}></Label>;
        }
        return (<div className="wrap_i" {...attr}>{labelComponent}{widgetComponent}</div>);
    },

    _getWidgetName: function() {
        return this.props.options["widget"]["widgetName"];
    },

    getWidget: function() {
        return this.refs[this._getWidgetName()];
    }
});
