/**
 * Created by Wei on 15/12/28.
 */
var React = require('react');
var ReactDOM = require('react-dom');
var Widget = require('../widget');
var ComboList = require("./comboList");
var ComboItem = require("./comboItem");
var Trigger = require("./triggerEditor");
var BaseUtils = require("../../../utils/baseUtils");

module.exports = React.createClass({
    mixins : [Widget, Trigger],
    hasClearItem : false,

    componentDidMount: function () {
        this.makeTriggerVisible();
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this.refs.combo)), this.showList);
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this.refs.arrow)), this.showList);
        this.afterWidgetInit();

    },

    getInitialState: function () {
        return {
            data: [],
            selectedIndex: -1
        };
    },

    componentWillMount: function() {
        var self = this;
        var options = this.props.options;
        if(options.controlAttr && options.controlAttr.data) {
            var selectedIndex = -1;
            $.map(options.controlAttr.data, function(item, index) {
                self.needLoadMoreData = false;
                if(item["value"] == options.controlAttr.value || item["text"] == options.controlAttr.value) {
                    selectedIndex = index;
                }
            });
            self.updateData(options.controlAttr.data, selectedIndex);
        }
    },

    render: function() {
        var options = this.props.options;
        var text = this.state.selectedIndex >= 0 ? this.state.data[this.state.selectedIndex].text : "";
        var attr = this.getAttrFromOptions(options);
        return (<div className="h5-combo">
                    <div className="combo" {...attr} ref="combo">{text}</div>
                    <div className="arrow" ref="arrow"></div>
                    {<ComboList createItem={this.createItem} ref="comboList" checkLoad={this.checkLoad} data={this.state.data}></ComboList>}
                </div>
                );
    },

    createItem: function(index, text) {
        return <ComboItem type="combo" onClick={this.didItemClick} onTouchStart={this.touchStart} onTouchEnd={this.touchEnd}
                    isSelected={index == this.state.selectedIndex} text={text} key={index}/>;
    },

    didItemClick: function(e) {
        BaseUtils.stopEvent(e);
        var selectedItem = e.target;
        var items = $(selectedItem).parent().children();
        var selectedIndex = items.indexOf(selectedItem);
        if (this.state.selectedIndex >= 0) {
            $(items[this.state.selectedIndex]).removeClass("selected");
        }
        if (this.hasClearItem && selectedIndex == items.length - 1) {
            selectedIndex = -1;
            this.state.selectedIndex = -1;
        } else {
            $(items[selectedIndex]).addClass("selected");
            this.state.selectedIndex = selectedIndex;
        }
        this.collapse();
        this.setState({
            data: this.state.data,
            selectedIndex: selectedIndex
        });
        this.fireWidgetValueChange();
        this.fireEvent("afteredit", e);
    },

    touchStart: function(e) {
        var selectedItem = e.target;
        $(selectedItem).addClass("hover");
    },

    touchEnd: function(e) {
        var selectedItem = e.target;
        $(selectedItem).removeClass("hover");
    },

    updateData: function (data, selectedIndex) {
        if(!this.needLoadMoreData && !this.hasClearItem && this.props.options.allowBlank !== false) { //所有数据加载完，添加一个不选选项
            this.hasClearItem = true;
            data.push({text:"不选",value:""});
        }
        if(!selectedIndex && selectedIndex !== 0) {
            selectedIndex = this.state.selectedIndex;
        }
        this.setState({
            data: data,
            selectedIndex: selectedIndex
        });
    },

    getValue: function() {
        if(this.state.selectedIndex < 0) {
            return "";
        }
        return this.state.data[this.state.selectedIndex]["value"];
    },

    setValue: function(value) {
        var selectedIndex = -1;
        if(value) {
            $.map(this.state.data, function(item, index) {
                if(item["value"] == value) {
                    selectedIndex = index;
                }
            });
        }
        this.updateData(this.state.data, selectedIndex);
    },

    reset: function() {
        this.updateData([], -1);
    },

    collapse: function() {
        this.unbindTriggerEvent();
        $(ReactDOM.findDOMNode(this.refs["comboList"])).hide();
    }
});