var React = require("react");
var ReactDOM = require("react-dom");
var BaseUtils = require("../../../../utils/baseUtils");
var TreeNodeModel = require("./treeNodeModel");

/**
 * 树节点React组件
 */
module.exports = React.createClass({
    baseClass: "h5-tree-node",

    treeNodeModel: null,

    getInitialState: function() {
        return {
            isSelected: null,
            isExpand: null
        }
    },

    componentDidMount: function() {
        var self = this;
        BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this)), function() {
            if(self.treeNodeModel.hasChildren) {
                //先测试select
                self.props.didExpandNode(self);
            }
        });
        if(self.props.canSelect) {
            BaseUtils.createClickEvent($(ReactDOM.findDOMNode(this.refs["selector"])), function(e) {
                BaseUtils.stopEvent(e);
                self.props.didSelectNode(self);
            });
        }
    },

    render: function() {
        this.treeNodeModel = this.props.treeNodeModel;
        var placeHolders = [];
        var level = this.treeNodeModel.id.split("-").length - 1;
        for(var i = 0; i <= level; i ++) {
            placeHolders.push(this.createPlaceHolder(i));
        }
        placeHolders.push(this.createExpandHolder());
        placeHolders.push(this.createPlaceHolder(level + 1));
        var className = this.baseClass;
        if(this.isSelected()) {
            className += (" " + this.baseClass + "-selected");
        }
        if(this.isExpand()) {
            className += (" " + this.baseClass + "-expand");
        }
        return (
            <div className={className}>
                {placeHolders}
                {this.createNodeContent()}
                {this.createNodeSelector()}
            </div>
        );
    },

    createExpandHolder: function() {
        var className = (this.baseClass + "-placeholder") + (this.treeNodeModel.hasChildren ? (" " + this.baseClass + "-expandholder") : "");
        return <div key="expandHolder" className={className} />;
    },

    createPlaceHolder: function(i) {
        return <div key={"placeHolder" + i} className={this.baseClass + "-placeholder"} />;
    },

    createNodeContent: function() {
        return <div key="content" className={this.baseClass + "-content"}>{this.treeNodeModel.text}</div>;
    },

    createNodeSelector: function() {
        return this.props.canSelect ? (<div ref="selector" key="selector" className={this.baseClass + "-selector"}></div>) : null;
    },

    getTreeNodeModel: function() {
        return this.treeNodeModel;
    },

    getValue: function() {
        return this.treeNodeModel.getValue();
    },

    getShownIndex: function() {
        return this.props.shownIndex;
    },

    isExpand: function() {
        return this.state.isExpand !== null ? this.state.isExpand : this.props.isExpand
    },

    setExpand: function(expand) {
        this.setState({
            isExpand: expand
        });
    },

    isTreeNode: function() {
        return true;
    },

    setSelected: function(selected) {
        this.setState({
            isSelected: selected
        });
    },

    isSelected: function() {
        return this.state.isSelected !== null ? this.state.isSelected : this.props.isSelected
    }

});