/**
 * Created by Wei on 16/1/18.
 */

var React = require('react');
var ReactDOM = require('react-dom');
var BaseUtils = require("../../../utils/baseUtils");

module.exports = {
    startIndex: 0,
    filterIndex: 0,
    limitIndex: 5000,
    isLoading: false,
    needLoadMoreData: true,
    numberOfRecordsShownOnce: 500,  //show how many records once
    $view: null,

    //TODO: 统一的容器管理trigger控件
    makeTriggerVisible: function() {
        $(ReactDOM.findDOMNode(this)).parent().css("overflow", "visible");
    },

    checkLoad: function() {
        if(this.isLoading) {
            return;
        }
        if(this.needLoadMoreData) {
            this.loadData();
        }
    },

    loadData: function(filter, callback) {
        this.isLoading = true;
        var startIndex = filter ? this.filterIndex : this.startIndex;
        var self = this;
        var dependence = {};
        $.map(this.getLinkedWidgets(), function(linkedWidget) {
            dependence[linkedWidget.getWidgetName()] = linkedWidget.getValue();
        });
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: 'text',
            data: {
                dependence: BaseUtils.jsonEncode(dependence),
                startIndex: startIndex,
                limitIndex: self.limitIndex,
                filter: filter,
                reload: true,
                op: "widget",
                cmd: "getdata",
                widgetname: self.props.options.widgetName,
                sessionID: self.props.options.sessionID,
            },
            type: 'POST',
            success: function(responseObject) {
                var jsonData = BaseUtils.jsonDecode(responseObject);
                self.isLoading = false;
                var tempData = self.state.data.concat(jsonData);
                self.needLoadMoreData = jsonData.length >= self.limitIndex;
                if(filter) {
                    self.filterIndex = self.state.data.length;
                } else {
                    self.startIndex = self.state.data.length;
                }
                self.updateData(tempData);
                if($.isFunction(callback)) {
                    callback(jsonData);
                }
            },
        });
    },

    showList: function(e) {
        if(this.props.options.disabled) {
            return ;
        }
        var self = this;
        if(this.$view && this.$view[0].style.display === "block") {
            this.collapse(e);
        } else {
            var list = $(ReactDOM.findDOMNode(this.refs.comboList));
            this.$view = list;
            this.bindTriggerEvent();
            list[0].style.display = "block";
            list.width(list.parent().width());
            if(this.isLoading) {
                return ;
            }
            if(this.state.data.length === 0 || ($.isFunction(this.needLoadData) && this.needLoadData())) {
                this.loadData("", function(jsonData) {
                    if($.isFunction(self.afterLoadData)) {
                        self.afterLoadData(jsonData);
                    }
                });
            }
        }
    },

    bindTriggerEvent: function() {
        $(document).bind("click", this.collapseIf).bind("scroll", this.collapseIf);
    },

    unbindTriggerEvent: function() {
        $(document).unbind("click", this.collapseIf).unbind("scroll", this.collapseIf);
    },

    collapseIf: function (e) {
        var combo = $(ReactDOM.findDOMNode(this.refs.combo));
        if (e.pageX == null ||
            ((e.pageX < this.$view.offset().left || e.pageX > this.$view.offset().left + this.$view.width()
            || e.pageY < (this.$view.offset().top - combo.height()) || e.pageY > this.$view.offset().top + this.$view.height()))) {
            if((typeof this.collapse) == "function") {
                this.collapse(e);
            } else {
                console.error("Trigger Widget has no collapse method.");
            }
        }
    },

    isValidate: function() {
        if(!this.validateBlank()) {
            this.errorMsg = BaseUtils.unicode2CJK("z503cz4e0dz5141z8bb8z4e3az7a7a");
            return false;
        }
        return true;
    }
};