/**
 * Created by Wei on 15/12/28.
 */
var React = require("react");
var BaseUtils = require("../../utils/baseUtils");

module.exports = {

    errorMsg: BaseUtils.unicode2CJK("z503cz4e0dz5728z5408z7406z8303z56f4z5185"),

    afterWidgetInit: function() {
        if(typeof this.props.options.initLink == "function") {
            this.props.options.initLink(this, this.props.options.value);
        }
        this.fireEvent("afterinit");
    },

    getAttrFromOptions: function(options) {
        var attr = {};
        var style = {};
        attr.placeholder = options.watermark;
//        style.fontSize = options.fontSize;
        if(options.invisible) {
            style.display = "none";
        }
        if(options.disabled) {
            style.opacity = "0.5";
            attr.disabled = true;
        }
        attr.style = style;
        attr.initLink = options["initLink"];
        return attr;
    },

    initLinkManager: function() {
        if(!this.linkManager) {
            this.linkManager = {};
            this.linkManager.linkedWidgets = [];
            this.linkManager.linkWidgets = [];
        }
    },

    pushLinkWidget: function(widget) {
        this.initLinkManager();
        if(widget) {
            this.linkManager.linkWidgets.push(widget);
        }
    },

    pushLinkedWidget: function(widget) {
        this.initLinkManager();
        if(widget) {
            this.linkManager.linkedWidgets.push(widget);
        }
    },

    fireWidgetValueChange: function() {
        this.props.options.fireWidgetValueChange(this);
    },

    getWidgetName: function() {
        return this.props.options.widgetName;
    },

    getLinkWidgets: function() {
        this.initLinkManager();
        return this.linkManager.linkWidgets || [];
    },

    getLinkedWidgets: function() {
        this.initLinkManager();
        return this.linkManager.linkedWidgets || [];
    },

    getSessionID:function(){
        return this.props.options.sessionID || "";
    },

    fireEvent: function(eventName, event) {
        var self = this;
        var listeners = this.props.options.listeners ? this.props.options.listeners : [];
        $.map(listeners, function(listener) {
            if(listener.eventName == eventName) {
                if($.isFunction(listener.action)) {
                    try {
                        listener.action.call(self, event);
                    } catch(e) {
                    }
                } else {
                    var action = listener.action.replace(/\n/g,"");
                    try {
                        (new Function("(" + action + ").apply(this, arguments)")).apply(self, arguments);
                    } catch(e) {
                    }
                }
            }
        });
    },

    validateBlank: function() {
        return this.props.options.allowBlank !== false || this.getValue().toString() != "";
    },

    getErrorMessage: function() {
        return this.props.options.errorMsg ? this.props.options.errorMsg : this.errorMsg;
    },

    getBorderStyle: function() {
        var options = this.props.options;
        var borderStyle = options.borderStyle || options.border;
        return borderStyle ? {
            borderWidth: borderStyle.width + "px",
            borderStyle: borderStyle.type,
            borderColor: borderStyle.color
        } : {};
    }
}