/**
 * Created by Wei on 15/12/31.
 */
var React = require("react");
var ReactDOM = require("react-dom");

module.exports = {
    createWidget: function(options) {
        var widgetName = options.widgetName;
        if(widgetName) {
            widgetName = widgetName.toUpperCase();
        }
        var widgetOptions = {
            options: options
        }
        if(widgetName) {
            widgetOptions.ref = widgetName;
        }
        switch (options.type) {
            case "label":
                var Label = require("./label");
                return <Label {...widgetOptions} />;
            case "text":
                var TextEditor = require("./input/texteditor");
                return <TextEditor {...widgetOptions} />;
            case "textarea":
                var TextArea = require("./input/textarea");
                return <TextArea {...widgetOptions} />;
            case "number":
                var NumberEditor = require("./input/numbereditor");
                return <NumberEditor {...widgetOptions} />;
            case "radiogroup":
                var RadioGroup = require("./group/radiogroup");
                return <RadioGroup {...widgetOptions} />;
            case "checkboxgroup":
                var CheckBoxGroup = require("./group/checkgroup");
                return <CheckBoxGroup {...widgetOptions} />;
            case "datetime":
                var DateTimeEditor = require("./dateEditor");
                return <DateTimeEditor {...widgetOptions} />;
            case "combo":
                var ComboBoxEditor = require("./trigger/comboBox");
                return <ComboBoxEditor {...widgetOptions} />;
            case "tagcombocheckbox":
            case "combocheckbox":
                var ComboCheckBox = require("./trigger/comboCheckBox");
                return <ComboCheckBox {...widgetOptions} />;
            case "button":
                var Button = require("./button");
                return <Button {...widgetOptions} />;
            case "submitButton":
                var SubmitButton = require("./submitbutton");
                return <SubmitButton {...widgetOptions} />;
            case "cancelButton":
                var CancelButton = require("./cancelButton");
                return <CancelButton {...widgetOptions} />;
            case "scale":
                var Scale = require("./scale");
                return <Scale {...widgetOptions} />;
            case "title":
                var TitleWidget = require("../form/titleWidget");
                return <TitleWidget {...widgetOptions} />;
            case "elementcase":
                var ReportElementCase = require("../form/elementcase");
                return <ReportElementCase {...widgetOptions} isAutoLayout={options.isAutoLayout} sessionID={options.sessionID} />
            case "chartwidget":
                var Chart = require("./chart");
                return <Chart {...widgetOptions} chartWidth={options.width} chartHeight={options.height} />
            case "treecombobox":
            case "tree":
                var TreeComboBox = require("./trigger/tree/treeComboBox");
                return <TreeComboBox {...widgetOptions} />
            default :
                return null;
        };
    }
};