;

var BridgeUtils = require("./utils/bridgeUtils");

var Private = {

    clearItemWithPrefix: function(prefix) {
        $.map(localStorage, function(item, index){
            var key = localStorage.key(index);
            if(key.indexOf(prefix) === 0) {
                localStorage.removeItem(key);
            }
        });
    },

    /**
     *  key: 关键字,包括版本号（key=keyPrefix+"_"+version）
     *  path: 资源在服务器上的路径
     *  keyPrefix: 资源前缀
     */
    readFileFromLS: function(key, path, keyPrefix) {
        var self = this;
        var LS = window.localStorage;
        if(LS && LS.getItem(key)) {
            var script = document.createElement('script');
            var code = '!function(){' + LS.getItem(key) + '\n}();';
            script.appendChild(document.createTextNode(code));
            document.head.appendChild(script);
        } else {
            $.ajax({
                url: "${servletURL}",
                async: false,
                data: {
                    op: "resource",
                    resource: path,
                    encode: "utf8",
                    __time__: (new Date()).getTime()
                },
                dataType: "text",
                success: function(result){
                    //清除原来的
                    self.clearItemWithPrefix(keyPrefix);
                    var script = document.createElement('script');
                    var code = '!function(){' + result + '\n}();';
                    script.appendChild(document.createTextNode(code));
                    document.head.appendChild(script);
                    LS.setItem(key, result);
                },
                error: function() {
                    alert("get js error:" + key);
                }
            });
        }
    }
}

//获取服务器上的js版本
$.ajax({
    url: "${servletURL}",
    async: false,
    data: {
        op: "h5_file_version",
        __time__: (new Date()).getTime()
    },
    dataType: "json",
    success: function(result) {
        var h5Version = result["h5"];
        var vanChartsVersion = result["vanCharts"];
        Private.readFileFromLS("h5Report_" + h5Version, "/com/fr/wei/plugin/h5reportnew/dist/h5.js", "h5Report");
        Private.readFileFromLS("d3_" + vanChartsVersion, "/com/fr/web/core/js/d3.js", "d3");
        Private.readFileFromLS("vanCharts_" + vanChartsVersion, "/com/fr/web/core/js/vancharts-modern.js", "vanCharts");
        Private.readFileFromLS("vanCharts_map_" + vanChartsVersion, "/com/fr/web/core/js/leaflet.js", "vanCharts_map");
    },
    error: function() {
        alert("get version fail");
    }
});

var registerCloseSession = function(sessionID) {
    $(window).unload(function () {
        if (sessionID) {
            $.ajax({
                async: false,
                url: "${servletURL}",
                data: {
                    op: 'closesessionid',
                    sessionID: sessionID
                }
            });
        }
    });
};

window.H5Entry = {
    enterReport: function(sessionID, corpID, timeStamp, nonceStr, signature, entryID) {
        registerCloseSession(sessionID);
        BridgeUtils.initBridge(function() {
            FRH5ReportUtils.enterReport(sessionID, corpID, timeStamp, nonceStr, signature, entryID);
        });
    },

    enterForm: function(sessionID, isSubmit, corpID, timeStamp, nonceStr, signature) {
        registerCloseSession(sessionID);
        BridgeUtils.initBridge(function() {
            FRH5ReportUtils.enterForm(sessionID, isSubmit, corpID, timeStamp, nonceStr, signature);
        });
    },

    enterFS: function(corpid, timeStamp, nonceStr, signature) {
        FRH5ReportUtils.renderFS(corpid, timeStamp, nonceStr, signature);
    }
};