module.exports = function(){
    var less = require('less'),
        fs = require('fs');

    function compileLessFiles(folderOptions){
        var optionsList = folderOptions.lessFolderOptions;
        var lessString = "";
        for(var index in optionsList){
            var options = optionsList[index];

            if(options.inputLessFiles){
                for(var fileIndex in options.inputLessFiles){
                    var file = options.inputLessFiles[fileIndex];
                    lessString += this.getImportFile(options.baseFolder, file);

                }
                toCSS(lessString,{}, folderOptions.outputFolder, folderOptions.outputCssFile);
            }else{
                var lessOptions = {
                    paths: [options.baseFolder]
                };
                fs.readdirSync(options.baseFolder).forEach(function(file){
                    if (! /\.less/.test(file)) {
                        return;
                    }
                    lessString += getImportFile(options.baseFolder, file);
                });
                toCSS(lessString, lessOptions, folderOptions.outputFolder, folderOptions.outputCssFile);

            }
        }
    }

    function toCSS(inputLess, options, outputFolder, outputFile){

        less.render(inputLess, options).then(function(output) {
            fs.exists(outputFolder, function(exist){
                        if(!exist){
                            fs.mkdir(outputFolder);
                        }
                    fs.writeFileSync(outputFolder + outputFile, output.css);

                });
            },
            function(error) {
                console.log(error);
            });
    }

    function getImportFile(folderPath, fileName){
        return "@import '"+folderPath+fileName+"';";
    }

    return{
        compileLessFiles: compileLessFiles
    }

}