var HyperLinkUtils = require("../utils/hyperLinkUtils");
var BaseUtils = require("../utils/baseUtils");
//支持超链需要的FR常用方法,放在这里

Function.prototype.createDelegate = function(obj) {
    var method = this;
    var args = arguments[1];
    var appendArgs = arguments[2];
    return function () {
        var callArgs = args || arguments;
        if (appendArgs === true) {
            callArgs = Array.prototype.slice.call(arguments, 0);
            callArgs = callArgs.concat(args);
        } else if (typeof appendArgs == "number") {
            callArgs = Array.prototype.slice.call(arguments, 0);
            // copy arguments first
            var applyArgs = [appendArgs, 0].concat(args);
            // create method call params
            Array.prototype.splice.apply(callArgs, applyArgs);
            // splice them in
        }
        return method.apply(obj, callArgs);
    };
};

module.exports = {

    sid: null,

    tc : function(fn, context, args) {
        try {
            return fn.apply(context, args);
        } catch (e) {
            console.error(e);
            throw e;
        }
    },

    doHyperlinkByGet: function (url, para, target) {
        HyperLinkUtils.doHyperlinkByGet(url,para,target);
    },

    doHyperlinkByPost: function (url, para, target) {
        HyperLinkUtils.doHyperlinkByPost(url,para,target);
    },

    Msg:{
        //先简单实现
        toast:function(msg) {
            alert(msg);
        },

        alert:function (title,msg) {
            alert(msg);
        },

        confirm:function (title,msg) {
           confirm(msg);
        }
    },

    formulaEvaluator: function (formula, initValue, must) {
        var lazyValue = initValue;
        return function (nocache) {
            //如果后台没有计算出公式结果initValue, 那再去remoteEval
            //这边之前写!lazyValue , 遇到lazyValue = 0时就会重复计算
            if (nocache || lazyValue == undefined || must) {
                try {
                    lazyValue = this.remoteEvaluate(formula);
                } catch (e) {
                    // 说明不需要到服务器端取数
                }
            }

            return lazyValue;
        }
    },

    remoteEvaluate: function (formula) {
        var result = null;
        //post只需要encode一次, get两次
        formula = encodeURIComponent(formula);
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            type: 'POST',
            async: false,
            data: {
                op: 'fr_base',
                cmd: 'evaluate_formula',
                sessionID: this.getSessionID(),
                expression: formula
            },
            timeout: 5000,
            success: function (res) {
                result = BaseUtils.jsonDecode(res);
                result = result["result"];
            }
        });

        return result;
    },

    registerSessionID: function(sessionID) {
        this.sid = sessionID;
    },

    getSessionID: function() {
        return this.sid;
    },

    cjkEncode: function(text) {
        return BaseUtils.cjkEncode(text);
    },

    cjkDecode: function(text) {
        return BaseUtils.cjkDecode(text);
    }
}

