;

//h5插件的统一入口,包括报表/表单/决策系统
var React = require('react');
var ReactDOM = require('react-dom');
var ParameterPane = require("../components/parameter/parameterComponents");
var FastClick = require("fastclick");
var BaseUtils = require("../utils/baseUtils");
var LoadingUtils = require("../utils/loadingUtils");
require("../style/iconfont/frmobilefont.css");
require("../lib/dingtalk");
var BridgeUtils = require("../utils/bridgeUtils");
window.FR = require("../lib/frnormal");

var Private = {

    getParameterContainer: function() {
        return document.getElementById("parameter-container");
    },

    getReportContainer: function() {
        return document.getElementById("report-container");
    },

    getFormContainer: function() {
        return document.getElementById("form-container");
    },

    getCancelButton: function() {
        return document.getElementById("h5-cancel-wrap");
    },

    hideContainerClassName: "h5-container-hide",

    animateParameterClassName: "h5-parameter-container-animation"
};

//fastclcik
(function() {
    window.addEventListener('load', function() {
        new FastClick(document.body);
    }, false);
})();

window.FRH5ReportConstants = {
    servletURL:"${servletURL}",
    op: "h5",
    serverURL:"${serverURL}"
};

Function.prototype.clone = function() {
    var that = this;
    var temp = function temporary() { return that.apply(this, arguments); };
    for(var key in this) {
        if (this.hasOwnProperty(key)) {
            temp[key] = this[key];
        }
    }
    return temp;
};

window.FRH5ReportUtils = {
    toolBar: null,

    //进入cpt的第一入口
    enterReport: function(sessionID, corpID, timeStamp, nonceStr, signature, entryID) {
        var self = this;
        var isReport = true;
        if(corpID && corpID != "-1") {
            this.login2DingDing(corpID, timeStamp, nonceStr, signature, function(dingtalkResult) {
                if(entryID) {
                    BaseUtils.ajax({
                        url: FRH5ReportConstants.servletURL,
                        dataType: "text",
                        data: {
                            op: "h5",
                            cmd: "entry_report",
                            code: dingtalkResult.code,
                            id: entryID,
                            needJSON: true,
                        },
                        success: function(result) {
                            var jsonData = BaseUtils.jsonDecode(result);
                            self.renderReport(BaseUtils.getSessionID(jsonData), false);
                        },
                        error: function() {
                            alert("error while op=h5&cmd=entry_report");
                        }
                    });
                } else if(sessionID) {
                    self.getParameterData(sessionID, "h5_para_json", function(parameterJSON) {
                        if(!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                            self.renderReport(sessionID, false);
                        } else {
                            self.renderParameter(parameterJSON, sessionID, true, parameterJSON["delay"]);
                        }
                    }, dingtalkResult.code);
                }
            });
            return;
        }
        if(sessionID) {
            this.getParameterData(sessionID, "h5_para_json", function(parameterJSON) {
                if(!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                    self.renderReport(sessionID, false);
                } else {
                    self.renderParameter(parameterJSON, sessionID, true, parameterJSON["delay"]);
                }
            });
        } else if(entryID) {
            this.getEntryParameterData(entryID, function(parameterJSON) {
                var sessionID = BaseUtils.getSessionID(parameterJSON);
                if(!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                    self.renderReport(sessionID, false);
                } else {
                    self.renderParameter(parameterJSON, sessionID, true, parameterJSON["delay"]);
                }
            });
        }
    },

    getEntryParameterData: function(entryID, onSuccess) {
        LoadingUtils.showLoading();
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: "text",
            data: {
                op: "h5_entry_json",
                id: entryID
            },
            type: "POST",
            success: function(result) {
                LoadingUtils.hideLoading();
                var parameterJSON = BaseUtils.jsonDecode(result);
                if($.isFunction(onSuccess)) {
                    onSuccess.call(self, parameterJSON);
                }
            },
            error: function() {
                LoadingUtils.hideLoading();
            }
        });
    },

    //请求参数面板json
    getParameterData: function(sessionID, op, onSuccess, code) {
        var self = this;
        LoadingUtils.showLoading();
        var data = {
            sessionID: sessionID,
            op: op
        };
        if(code) {
            data["code"] = code;
        }
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: "text",
            data: data,
            type: "POST",
            success: function(result) {
                LoadingUtils.hideLoading();
                var parameterJSON = BaseUtils.jsonDecode(result);
                if($.isFunction(onSuccess)) {
                    onSuccess.call(self, parameterJSON);
                }
            },
            error: function() {
                alert("error while get parameter json");
                LoadingUtils.hideLoading();
            }
        });
    },

    //展示报表的参数界面
    renderParameter: function(parameterJSON, sessionID, isReport, isDelay) {
        var self = this;
        this.beforeShowParameter();
        ReactDOM.render(
            <ParameterPane isDelay={isDelay} key={(new Date()).getTime()} options={parameterJSON} onSubmit={function() {
                self.onSubmit(sessionID, {
                    isReport: isReport
                });
            }}></ParameterPane>,
            Private.getParameterContainer()
        );
    },

    //展示报表内容
    renderReport: function(sessionID, hasParameter) {
        var self = this;
        self.beforeShowContent();
        var Report = require("../components/report/reportComponents");
        require("../style/finereport.css");
        LoadingUtils.showLoading();
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: "text",
            data: {
                sessionID: sessionID,
                op: "h5_report_content_json",
                pn: 1
            },
            type: "POST",
            success: function(reportResult) {
                LoadingUtils.hideLoading();
                var Report = require("../components/report/reportComponents");
                var jsonData = BaseUtils.jsonDecode(reportResult);
                ReactDOM.render(
                    <Report key={(new Date()).getTime()} options={jsonData} hasParameter={hasParameter}></Report>,
                    Private.getReportContainer()
                );
            },
            error: function() {
                LoadingUtils.hideLoading();
                alert("failure to get report content");
            }
        });
    },

    //点击加载时才加动画
    beforeClick: function() {
        $(Private.getParameterContainer()).addClass(Private.animateParameterClassName);
    },

    //展示参数界面前的准备工作,把报表/表单容器隐藏
    beforeShowParameter: function() {
        $(Private.getReportContainer()).addClass(Private.hideContainerClassName);
        $(Private.getFormContainer()).addClass(Private.hideContainerClassName);
        var showCancelButtonFunction = function() {
            $(Private.getCancelButton()).removeClass("h5-cancel-hidden");
        };
        if($(Private.getParameterContainer()).hasClass(Private.animateParameterClassName)) {
            Private.getParameterContainer().addEventListener("webkitTransitionEnd", showCancelButtonFunction);
        } else {
            showCancelButtonFunction();
        }
        BaseUtils.setTranslate3D($(Private.getParameterContainer()), "translate3d(0, 0, 0)");
    },

    //展示报表/表单前的准备工作,把参数面板移出视图外
    beforeShowContent: function() {
        var self = this;
        var showContentFunction = function() {
            $(Private.getReportContainer()).removeClass(Private.hideContainerClassName);
            $(Private.getFormContainer()).removeClass(Private.hideContainerClassName);
            Private.getParameterContainer().removeEventListener("webkitTransitionEnd", showContentFunction);
        }
        if($(Private.getParameterContainer()).hasClass(Private.animateParameterClassName)) {
            Private.getParameterContainer().addEventListener("webkitTransitionEnd", showContentFunction);
        } else {
            showContentFunction();
        }
        BaseUtils.setTranslate3D($(Private.getParameterContainer()), "translate3d(0, " + BaseUtils.getWindowHeight() + "px, 0)");
    },

    //进入表单的第一入口
    enterForm: function(sessionID, entryID, corpID, timeStamp, nonceStr, signature) {
        var self = this;
        if(corpID && corpID != "-1") {
            this.login2DingDing(corpID, timeStamp, nonceStr, signature, function(dingtalkResult) {
                if(sessionID) {
                    self.getParameterData(sessionID, "h5_form_para", function(parameterJSON) {
                        if(!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                            self.renderForm(sessionID, false);
                        } else {
                            self.renderParameter(parameterJSON, sessionID, false, parameterJSON["delay"]);
                        }
                    }, dingtalkResult.code);
                }
            });
            return;
        }
        if(sessionID) {
            this.getParameterData(sessionID, "h5_form_para", function (parameterJSON) {
                if (!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                    self.renderForm(sessionID, false);
                } else {
                    self.renderParameter(parameterJSON, sessionID, false, parameterJSON["delay"]);
                }
            });
        } else if(entryID) {
            this.getEntryParameterData(entryID, function(parameterJSON) {
                var sessionID = BaseUtils.getSessionID(parameterJSON);
                if (!parameterJSON["parameter"] || !parameterJSON["isShowWindow"]) {
                    self.renderForm(sessionID, false);
                } else {
                    self.renderParameter(parameterJSON, sessionID, false, parameterJSON["delay"]);
                }
            });
        }
    },

    //展示表单内容
    renderForm: function(sessionID, hasParameter) {
        var self = this;
        self.beforeShowContent();
        LoadingUtils.showLoading();
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: "text",
            data: {
                sessionID: sessionID,
                op: "fr_form",
                cmd: "load_content"
            },
            type: "POST",
            success: function(formResult) {
                LoadingUtils.hideLoading();
                var jsonData = BaseUtils.jsonDecode(formResult);
                jsonData.sessionID = sessionID;
                var Form = require("../components/form/form");
                require("../style/finereport.css");
                ReactDOM.render(
                    <Form key={(new Date()).getTime()} options={jsonData} hasParameter={hasParameter}></Form>,
                    Private.getFormContainer()
                );
            },
            error: function() {
                LoadingUtils.hideLoading();
                alert("failure to get form content");
            }
        });
    },

    renderFS: function(corpID, timeStamp, nonceStr, signature) {
        var self = this;
        if(corpID && corpID != "-1") {
            this.login2DingDing(corpID, timeStamp, nonceStr, signature, function(dingtalkResult) {
                self.showFS(dingtalkResult.code);
            });
        } else {
            self.showFS();
        }

    },

    showFS: function(code) {
        var self = this;
        LoadingUtils.showLoading();
        BaseUtils.ajax({
            url: FRH5ReportConstants.servletURL,
            dataType: "text",
                data: {
                    code: code,
                    op: "h5_fs_json",
                    state: "dingtalk",
                    id: -1
                },
                type: "POST",
                success: function(fsResult) {
                    var jsonData = BaseUtils.jsonDecode(fsResult);
                    LoadingUtils.hideLoading();
                    var DirectoryTree = require("../components/fs/directoryTree");
                    ReactDOM.render(<DirectoryTree options={jsonData["rootReports"]} icons={jsonData["folderIcons"]}></DirectoryTree>,
                        document.getElementById("h5-fs-container"));
                },
                error: function() {
                    LoadingUtils.hideLoading();
                }
        });
    },

    login2DingDing: function(corpId, timeStamp, nonceStr, signature, onSuccess) {
        var self = this;
        dd.config({
            agentId: "",
            corpId: corpId,
            timeStamp: timeStamp,
            nonceStr: nonceStr,
            signature: signature,
            jsApiList: ['runtime.info', 'runtime.permission.requestAuthCode']
        });
        dd.ready(function() {
            dd.runtime.permission.requestAuthCode({
                corpId: corpId,
                onSuccess: function(result) {
                    if(onSuccess) {
                        onSuccess.call(self, result);
                    }
                },
                onFail : function(err) {
                    alert(JSON.stringify(err));
                }
            })
        });
        dd.error(function(error) {
            alert(JSON.stringify(error));
        });
    },

    //参数面板提交事件
    onSubmit: function(sessionID, parameters) {
        $(Private.getReportContainer()).empty();
        if(parameters.isReport) {
            this.renderReport(sessionID, true);
        } else {
            this.renderForm(sessionID, true);
        }
    }
};