;

//wei: 用于和App通信,主要用于App集成H5
//开放接口:
//  超链:
//    iOS:
//      window.JSBridge.callHandler("hyperLinkHandler", {
//        url: hyperLinkUrl,
//        name: hyperLinkName
//      });
//    android:
//      window.JSBridge.handleHyperLink(hyperLinkUrl, hyperLinkName);
//  报表请求数据加密解密（其中加密解密由App完成）:
//    加密:
//      iOS:
//        window.JSBridge.callHandler("dataEncrypt", stringBeforeEncrypt, function(stringAfterEncrypt){...});
//      android:
//        window.JSBridge.dataEncrypt(stringBeforeEncrypt, "window.JSBridge.encryptResultHandler"); //window.JSBridge.encryptResultHandler为加密后回调的方法名
//    解密:
//      iOS:
//        window.JSBridge.callHandler("dataDecrypt", stringBeforeDecrypt, function(stringAfterDecrypt){...});
//      android:
//        window.JSBridge.dataDecrypt(stringBeforeDecrypt, "window.JSBridge.decryptResultHandler"); //window.JSBridge.decryptResultHandler为解密后回调的方法名

var Private = {
    initBridge4iOS:function(afterInitBridge) {
        var setupWebViewJavascriptBridge = function(callback) {
            //如果桥接对象已存在，则直接调用callback函数
            if (window.WebViewJavascriptBridge) {
                return callback(WebViewJavascriptBridge);
            }
            if (window.WVJBCallbacks) {
                return window.WVJBCallbacks.push(callback);
            }
            window.WVJBCallbacks = [callback];
            var WVJBIframe = document.createElement('iframe');
            WVJBIframe.style.display = 'none';
            WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
            document.documentElement.appendChild(WVJBIframe);
            setTimeout(function () {
                document.documentElement.removeChild(WVJBIframe);
                afterInitBridge();
            }, 0)
        }
        setupWebViewJavascriptBridge(function(bridge) {
            window.JSBridge = bridge;
        });
    },

    initBridge4Android:function(afterInitBridge) {
        //安卓端使用webview的addJavascriptInterface方法注册JSBridge对象
        afterInitBridge();
    }
};

module.exports = {
    //初始化JSBridge
    initBridge: function(callback) {
        window.addEventListener('load', function() {
            device.ios() ? Private.initBridge4iOS(callback) : Private.initBridge4Android(callback);
        });
    },

    dealWithHyperLink: function(hyperLinkUrl, hyperLinkName) {
        var jsBridge = window.JSBridge;
        if(jsBridge.callHandler) {
            jsBridge.callHandler("hyperLinkHandler", {
                url: hyperLinkUrl,
                name: hyperLinkName
            });
        } else if(jsBridge.handleHyperLink) {
            jsBridge.handleHyperLink(hyperLinkUrl, hyperLinkName);
        }
    }
};