var Private = {
    chartMap: {}
};

module.exports = {
    isChartPainting: false,

    addChart: function (id, chart) {
        Private.chartMap[id] = chart;
    },

    getChartStartWith: function (idPrefix) {
        for (var id in Private.chartMap) {
            if (id.indexOf(idPrefix) === 0) {
                return Private.chartMap[id];
            }
        }
        return null;
    },

    drawChart: function(vanCharts, chartAttr, isUpdate) {
        var self = this;
        //多个svg同时绘制时,浏览器会延迟绘制,造成界面上空白很久,然后所有图表同时展示出来.这里给每个图表500ms的绘制时间缓解这个问题
        if(self.isChartPainting) {
            setTimeout(function() {
                self.drawChart(vanCharts, chartAttr, isUpdate);
            }, 100);
        } else {
            self.isChartPainting = true;
            isUpdate ? vanCharts.setData(chartAttr) : vanCharts.setOptions(chartAttr);
            setTimeout(function() {
                self.isChartPainting = false;
            }, 500);
        }
    },

    clear: function() {
        Private.chartMap = {};
    }
}