var React = require("react");
var ReactDOM = require("react-dom");
var Loading = require("../components/widget/loading");
var BaseUtils = require("./baseUtils");

module.exports = {

    showLoading: function() {
        var self = this;
        if(!this.showID) {
            this.showID = setTimeout(function() {
                if(!self.loading) {
                    self.loading = ReactDOM.render(<Loading></Loading>, self.createMask()[0]);
                }
                self.showMask();
                self.loading.show();
            }, 500);   //超出0.5s的才显示loading
        }
    },

    hideLoading: function() {
        clearTimeout(this.showID);
        this.showID = 0;
        this.removeMask();
        if(this.loading) {
            this.loading.hide();
        }
    },

    createMask: function(isTransparent) {
        var self = this;
        var id = isTransparent ? "h5-mask-transparent" : "h5-mask";
        var mask = $("div#" + id);
        if(mask.length === 0) {
            mask = $("<div>").attr("id", id).appendTo($(document.body));
            BaseUtils.createClickEvent(mask, function(e) {
                if($(e.target).attr("id") == id) {
                    self.removeMask();
                }
            });
        }
        mask.css("display", "block");
        return mask;
    },

    showMask: function() {
        this.shownTime = (new Date()).getTime();
        $("div#h5-mask").css("display", "block");
        $("div#h5-mask-transparent").css("display", "block");
    },

    removeMask: function() {
        $("div#h5-mask").hide();
        $("div#h5-mask-transparent").hide();
    },
};