var webpack = require('webpack')
module.exports = {
    entry: {
        entry: "./entry.js",
        h5: "./pages/h5.js",
        device: "./lib/device.min.js",
        zepto: "./lib/zepto.js",
        html: ["./pages/report.html", "./pages/fs/fs.html", "./pages/fs/fslogin.html", "./pages/form.html"],
    },
    output: {
        filename: "[name].js",
        path: __dirname + "/dist",
        publicPath: "?op=resource&encode=utf8&resource=/com/fr/wei/plugin/h5reportnew/dist/"
    },
    module: {
        loaders: [
            {
                test: /\.js$/,
                exclude: /node_modules/,
                loader: "babel?presets[]=react,presets[]=es2015"
            },
            {
                test: /\.html$/,
                loader: "file?name=[name].[ext]"
            },
            {
                test: /\.png$/,
                loader: "url-loader?limit=10000"

            },
            {
                test: /\.css$/,
                loader: "style-loader!css-loader"
            }
        ]
    },
    plugins: [
       new webpack.optimize.UglifyJsPlugin({
           compress: {
               warnings: false
           }
       })
    ]
}